import _defineProperty from "@babel/runtime/helpers/defineProperty";
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
import React from 'react';
import { useLocation as useLocationReactRouterDOM } from 'react-router-dom';
import { debounce, isEnvironment } from '@amaui/utils';
const useLocation = props => {
  const {} = props || {};
  const locationReactRouterDOM = isEnvironment('browser') && !window.navigation ? useLocationReactRouterDOM() : null;
  const [response, setResponse] = React.useState(isEnvironment('browser') ? _objectSpread({}, window.location) : {});
  const onUpdate = React.useCallback(debounce(function () {
    let value = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _objectSpread({}, window.location);
    setResponse(value);
  }, 40), []);

  // React router DOM
  React.useEffect(() => {
    if (locationReactRouterDOM) onUpdate(locationReactRouterDOM);
  }, [locationReactRouterDOM]);
  const method = React.useCallback(() => {
    onUpdate();
  }, []);
  React.useEffect(() => {
    if (isEnvironment('browser')) return;

    // New API
    if (window.navigation) {
      window.navigation.addEventListener('navigate', method);
    }
    // Old method
    else {
      window.addEventListener('popstate', method);
      window.addEventListener('hashchange', method);
    }
    return () => {
      // Clean up
      // New API
      if (window.navigation) {
        window.navigation.removeEventListener('navigate', method);
      }
      // Old method
      else {
        window.removeEventListener('popstate', method);
        window.removeEventListener('hashchange', method);
      }
    };
  }, []);
  return response;
};
useLocation.displayName = 'amaui-UseLocation';
export default useLocation;